function varargout = FlukeStreamingGUI(varargin)
% FLUKESTREAMINGGUI MATLAB code for FlukeStreamingGUI.fig
%      FLUKESTREAMINGGUI, by itself, creates a new FLUKESTREAMINGGUI or raises the existing
%      singleton*.
%
%      H = FLUKESTREAMINGGUI returns the handle to a new FLUKESTREAMINGGUI or the handle to
%      the existing singleton*.
%
%      FLUKESTREAMINGGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FLUKESTREAMINGGUI.M with the given input arguments.
%
%      FLUKESTREAMINGGUI('Property','Value',...) creates a new FLUKESTREAMINGGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to t
%he GUI before FlukeStreamingGUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to FlukeStreamingGUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help FlukeStreamingGUI

% Last Modified by GUIDE v2.5 21-Jun-2017 11:37:06

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @FlukeStreamingGUI_OpeningFcn, ...
                   'gui_OutputFcn',  @FlukeStreamingGUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before FlukeStreamingGUI is made visible.
function FlukeStreamingGUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to FlukeStreamingGUI (see VARARGIN)

% Choose default command line output for FlukeStreamingGUI
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

%init look
set(handles.IMG,'xtick',[],'ytick',[]);

%init global members
setFilter1(false);
setFilter2(false);
setFilter3(false);
setTrackingMinMax(false);
setTrackingPoint(false);
setMinMax([]);
setPointTemp([]);
setPoint({});
setIMG(handles.IMG);
setGraph(handles.Graph);
setLastTimeStamp(clock);
setIsRecIS2Seq(false);
setMSPerIs2(1000);

%Add the dll's needed and any other import required
if ~IsAssemblyAdded('IRAccessNG.dll')
    if ~isdeployed
        %Get the Current path and load the assembly
        S = mfilename('fullpath');
        R = mfilename;
        L= length(R);
        cPath = S(1:end-L);
        asm = NET.addAssembly(fullfile(cPath, 'OpenAccess64', 'IRAccessNG.dll'));
        %asm = NET.addAssembly('C:\zSV\SmartView4_2\bin\Debug\IRAccessNG.dll');
        %asm = NET.addAssembly('C:\zSV\OpenAccess\IRAccessNG\bin\Release\IRAccessNG.dll')
    else
        asm = NET.addAssembly('C:\Program Files\FlukeStreamingGUI\application\OpenAccess64\IRAccessNG.dll');
    end
end
if ~IsAssemblyAdded('System.Drawing')
    NET.addAssembly('System.Drawing');
end
% if ~IsAssemblyAdded('System.Collections.Generic')
%     NET.addAssembly('System.Collections.Generic');
% end
import Fluke.Thermography.IRAccess.Streaming.*
import System.String

%start the engine manager
Fluke.Thermography.IRAccess.Streaming.StreamingCameraEngine.Start();
%disp('Startup Complete');
% UIWAIT makes FlukeStreamingGUI wait for user response (see UIRESUME)
 uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = FlukeStreamingGUI_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in DiscDevices.
function DiscDevices_Callback(hObject, eventdata, handles)
% hObject    handle to DiscDevices (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%disp('discover devices clicked');
%disable right after click
set(handles.DiscDevices, 'Enable', 'off'); 

%get the instance of the engine manager
EngMgr = Fluke.Thermography.IRAccess.Streaming.StreamingCameraEngine.Instance;  
%set(hObject,'EngMgr',EngMgr); %set app property

%task of finding device, this can be run on its own thread
%for now just search until one device is found.
DeviceCollection = EngMgr.GetCurrentGevCameras();
while DeviceCollection.Count == 0
    DeviceCollection = EngMgr.GetCurrentGevCameras();
    pause(0.02);
end
%set(hObject,'DeviceCollection',DeviceCollection); %set app property

%update the list
dcEnum = DeviceCollection.GetEnumerator();
newstring = {};
while dcEnum.MoveNext
    newitem = {char(dcEnum.Current.CameraSerial)};   
    newstring = {newitem{:}; newstring{:}}; %put on top 
    %disp(newstring);
end
set(handles.FoundDevices, 'str', newstring);   

%if any exist allow clicking in the found devices window
if ~isempty(get(handles.FoundDevices, 'str'))
    set(handles.FoundDevices, 'Enable', 'on');    
end

%get selected device, connect to device and enable streaming.
cval = get(handles.FoundDevices, {'string','value'});
if ~isempty(cval{1}(1))
    %connect
    sn = char(cval{1}(1));
    success = Fluke.Thermography.IRAccess.Streaming.StreamingCameraEngine.Instance.SelectDevice(sn); 
    if success
        %enable streaming
        set(handles.StartStream,'Enable','on');
    else
        set(handles.StartStream,'Enable','off');
    end    
else
    set(handles.StartStream,'Enable','off');
end

%enable after running
set(handles.DiscDevices, 'Enable', 'on'); 

%register callback for change in list



% --- Executes on button press in StartStream.
function StartStream_Callback(hObject, eventdata, handles)
% hObject    handle to StartStream (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%disable ASAP to prevent double click
set(handles.StartStream,'Enable','off');

%OLDER API
%global gImgSrcMgr %gCounter
%gCounter=0;
%starts stream
%gImgSrcMgr =  Fluke.Thermography.IRAccess.Streaming.ImageSourceManager( Fluke.Thermography.IRAccess.Streaming.StreamingCameraEngine.Instance.Engine);
%registers frame call back
%gImgSrcMgr.RegisterFrameCallback(@FrameCallback);

%close stream first
Fluke.Thermography.IRAccess.Streaming.StreamSource.Close();
%get engine
engine = Fluke.Thermography.IRAccess.Streaming.StreamingCameraEngine.Instance.Engine;
%starts stream
success =  Fluke.Thermography.IRAccess.Streaming.StreamSource.Open(engine);
%registers frame call back
Fluke.Thermography.IRAccess.Streaming.StreamSource.Instance.RegisterFrameCallback(@FrameCallback);
%subscribe to the what data we want in our callback
Fluke.Thermography.IRAccess.Streaming.StreamSource.Instance.Subscribe(Fluke.Thermography.IRAccess.Streaming.EventElements.All);


set(handles.StopStream,'Enable','on');

set(handles.TrackMinMax,'Enable','on');
set(handles.TrackPoint,'Enable','on');
set(handles.Filter1,'Enable','on');
set(handles.Filter2,'Enable','on');
set(handles.Filter3,'Enable','on');
set(handles.TakeIS2,'Enable','on');
set(handles.RecordIS2Sequence,'Enable','on');
set(handles.DisableFineOffset,'Enable','on');
set(handles.EnableFineOffset,'Enable','on');
set(handles.FireNUC,'Enable','on');
%set(handles.RecordIS2Sequence,'Enable','on'); % disable for now


% --- Executes on button press in StopStream.
function StopStream_Callback(hObject, eventdata, handles)
% hObject    handle to StopStream (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.StopStream,'Enable','off');

%OLDER API
% global gImgSrcMgr;
% gImgSrcMgr.UnregisterFrameCallback(@FrameCallback);
% %clean up the objec
% gImgSrcMgr.Dispose();

Fluke.Thermography.IRAccess.Streaming.StreamSource.Instance.UnregisterFrameCallback(@FrameCallback);
%clean up the object
Fluke.Thermography.IRAccess.Streaming.StreamSource.Close();
Fluke.Thermography.IRAccess.Streaming.StreamingCameraEngine.Instance.CloseCameraConnection();
%stop/starts discovery messages
%Fluke.Thermography.IRAccess.Streaming.StreamingCameraEngine.Instance.ProcessAvailableCameraTimerEvents = true;

set(handles.TrackMinMax,'Enable','off');
set(handles.TrackPoint,'Enable','off');
set(handles.Filter1,'Enable','off');
set(handles.Filter2,'Enable','off');
set(handles.Filter3,'Enable','off');
set(handles.TakeIS2,'Enable','off');
set(handles.RecordIS2Sequence,'Enable','off');
set(handles.DisableFineOffset,'Enable','off');
set(handles.EnableFineOffset,'Enable','off');
set(handles.FireNUC,'Enable','off');
%set(handles.RecordIS2Sequence,'Enable','off'); % not enabled this release
%discover devices call?



% --------------------------------------------------------------------
function FileMenu_Callback(hObject, eventdata, handles)
% hObject    handle to FileMenu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function OpenMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to OpenMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
file = uigetfile('*.fig');
if ~isequal(file, 0)
    open(file);
end


% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
printdlg(handles.figure1)

% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
                     ['Close ' get(handles.figure1,'Name') '...'],...
                     'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1


% --- Executes during object creation, after setting all properties.
% function popupmenu1_CreateFcn(hObject, eventdata, handles)
% % hObject    handle to popupmenu1 (see GCBO)
% % handles    empty - handles not created until after all CreateFcns called
% 
% % Hint: popupmenu controls usually have a white background on Windows.
% %       See ISPC and COMPUTER.
% if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
%      set(hObject,'BackgroundColor','white');
% end
% 
% set(hObject, 'String', {'plot(rand(5))', 'plot(sin(1:0.01:25))', 'bar(1:.5:10)', 'plot(membrane)', 'surf(peaks)'});
% % eventdata  reserved - to be defined in a future version of MATLAB


% --- Executes on selection change in FoundDevices.
function FoundDevices_Callback(hObject, eventdata, handles)
% hObject    handle to FoundDevices (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns FoundDevices contents as cell array
%        contents{get(hObject,'Value')} returns selected item from FoundDevices
%disp('Found devices callback');
cval = get(handles.FoundDevices, {'string','value'});
if ~isempty(cval{1})
    %connect
    sn = char(cval{1}(hObject.Value));
    success = Fluke.Thermography.IRAccess.Streaming.StreamingCameraEngine.Instance.SelectDevice(sn);  
    if success
        %enable streaming
        set(handles.StartStream,'Enable','on');
    else
        set(handles.StartStream,'Enable','off');
    end    
else
    set(handles.StartStream,'Enable','off');
end


% --- Executes during object creation, after setting all properties.
function FoundDevices_CreateFcn(hObject, eventdata, handles)
% hObject    handle to FoundDevices (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in TakeIS2.
function TakeIS2_Callback(hObject, eventdata, handles)
% hObject    handle to TakeIS2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%Disable capture buttons while working
%set(handles.RecordIS2Sequence, 'Enable', 'off');
set(handles.TakeIS2,  'Enable', 'off');

%default path is current folder
path = pwd;

%check the field to change path
userPath = get(handles.SaveFileLocation, 'string');
if exist(userPath)==7
    path=userPath;
else
    path = uigetdir;
end
%one last check to make sure the path exists
if exist(path)~=7
    path = pwd;
end

%update the location so the user will know where that file just went
set(handles.SaveFileLocation, 'string', path);
%take the is2
Fluke.Thermography.IRAccess.Streaming.StreamSource.Instance.ExecuteCaptureImage(path,false);

%Re-Enable when done working
%set(handles.RecordIS2Sequence, 'Enable', 'on');%disable for now
set(handles.TakeIS2,  'Enable', 'on');



function SaveFileLocation_Callback(hObject, eventdata, handles)
% hObject    handle to SaveFileLocation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of SaveFileLocation as text
%        str2double(get(hObject,'String')) returns contents of SaveFileLocation as a double


% --- Executes during object creation, after setting all properties.
function SaveFileLocation_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SaveFileLocation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on button press in FindSaveLocation.
function FindSaveLocation_Callback(hObject, eventdata, handles)
% hObject    handle to FindSaveLocation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

userPath = uigetdir;
set(handles.SaveFileLocation, 'string', userPath);


% --- Executes on button press in Filter1.
function Filter1_Callback(hObject, eventdata, handles)
% hObject    handle to Filter1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if getFilter1
    set(handles.Filter1,'string','Apply Contrast Stretch');
    setFilter1(false);
else
    set(handles.Filter1,'string','Remove Contrast Stretch');
    setFilter1(true);
end

% --- Executes on button press in TrackPoint.
function TrackPoint_Callback(hObject, eventdata, handles)
% hObject    handle to TrackPoint (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if getTrackingPoint
    set(handles.TrackPoint,'string','Track MidPoint Temperature');    
    setTrackingPoint(false);%set first!    
    setPointTemp([]); % clear data
else
    set(handles.TrackPoint,'string','Remove MidPoint Tracking');
    %get point
    setPoint({160,120}); %center point
        
    setTrackingPoint(true);%set last!
end

% --- Executes on button press in Filter2.
function Filter2_Callback(hObject, eventdata, handles)
% hObject    handle to Filter2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if getFilter2
    set(handles.Filter2,'string','Apply Sharpening');
    setFilter2(false);
else
    set(handles.Filter2,'string','Remove Sharpening');
    setFilter2(true);
end

% --- Executes on button press in TrackMinMax.
function TrackMinMax_Callback(hObject, eventdata, handles)
% hObject    handle to TrackMinMax (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if getTrackingMinMax %turn off
    set(handles.TrackMinMax,'string','Track Min Max Temperature');
    setTrackingMinMax(false);    
    setMinMax([]);
else %turn on
    set(handles.TrackMinMax,'string','Remove Min Max Tracking');
    setTrackingMinMax(true);
end

% --- Executes on button press in Filter3.
function Filter3_Callback(hObject, eventdata, handles)
% hObject    handle to Filter3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if getFilter3
    set(handles.Filter3,'string','Apply Edge Detection');
    setFilter3(false);
else
    set(handles.Filter3,'string','Remove Edge Detection');
    setFilter3(true);
end

% --- Executes on button press in Options.
function Options_Callback(hObject, eventdata, handles)
% hObject    handle to Options (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- framecallback
function FrameCallback(sender,args)
%sender object sender
%args FrameEventArgs
%disp('in frame cb');
%global gCounter
%gCounter = gCounter+1;
%disp(gCounter);
try
    %if sequencing
    if(getIsRecIS2Seq)
        %if desired time has passed
        if(etime(clock,getLastTimeStamp) > (getMSPerIs2/1000))
            setLastTimeStamp(clock);
            Fluke.Thermography.IRAccess.Streaming.StreamSource.Instance.ExecuteCaptureImage(getSeqPath, false);
            
            
        end
    end

    %read if args were set
    bitmap = args.IR_Bitmap.WasSet;
    temp = args.TemperatureData_Celcius.WasSet;

    if bitmap
        % read image Bitmap
        img = Net2MatImage(args.IR_Bitmap.Value);

        if getFilter1
            img = imadjust(img,stretchlim(img));
        end

        if getFilter2
            img = imsharpen(img);
            %img = imsharpen(img,'Radius',2,'Amount',1);
        end

        if getFilter3
             img = rgb2gray(img);
             img = edge(img,'zerocross');
             %log
             %zerocross --very good
             %Roberts
             %Sobel --good (standard)
             %Canny --noisy
             %Prewitt --nice
             %Find the axes handle
             %h = findobj('Tag', 'IMG');
             %special show image
             image(getIMG,img,'CDataMapping','scaled')

        else %the standard show image
            %h = findobj('Tag', 'IMG');
            image(getIMG, img);
        end
    end

    if temp
        if getTrackingMinMax
            %get min max
            s = single(args.TemperatureData_Celcius.Value);
            minVal = min(s(:));
            maxVal = max(s(:));
            addMinMaxValue([minVal,maxVal]);
            %h = findobj('Tag', 'Graph');
            plot(getGraph, getMinMax);
            if getTrackingPoint
                hold on
            end
        end

        if getTrackingPoint
            p = getPoint;
            temp = args.TemperatureData_Celcius.Value(p{1},p{2});
            addPointTemp(temp);    
            %graphHandle = findobj('Tag', 'Graph');
            plot(getGraph, getPointTemp);   
            if getTrackingMinMax
                hold off
            end
        end
    end
catch E
    msg = E;
end



% --- .net bitmap to matlab image
function img = Net2MatImage(bitmap)
bmp = bitmap;
w = bmp.Width;
h = bmp.Height;

% lock bitmap into memory for reading
bmpData = bmp.LockBits(System.Drawing.Rectangle(0, 0, w, h), ...
    System.Drawing.Imaging.ImageLockMode.ReadOnly, bmp.PixelFormat);

% get pointer to pixels, and copy RGB values into an array of bytes
num = abs(bmpData.Stride) * h;
bytes = NET.createArray('System.Byte', num);
System.Runtime.InteropServices.Marshal.Copy(bmpData.Scan0, bytes, 0, num);

% unlock bitmap
bmp.UnlockBits(bmpData);

% cleanup
clear bmp bmpData num

% convert to MATLAB image
bytes = uint8(bytes);
bb = bytes(1:4:end);
gg = bytes(2:4:end);
rr = bytes(3:4:end);
b = reshape(bb, [w,h])';
g = reshape(gg, [w,h])';
r = reshape(rr, [w,h])';
img = cat(3,r,g,b);


% --- Device change callback
function DeviceChangeCallback(sender, args)
    

% --- IMG handle
function setIMG(val)
global imgHandle
imgHandle = val;

function r = getIMG
global imgHandle
r = imgHandle;

% --- Graph handle
function setGraph(val)
global graphHandle
graphHandle = val;

function r = getGraph
global graphHandle
r = graphHandle;

% --- Filter 1
function setFilter1(val)
global f1
f1 = val;

function r = getFilter1
global f1
r = f1;

% --- Filter 2
function setFilter2(val)
global f2
f2 = val;

function r = getFilter2
global f2
r = f2;

% --- Filter 3
function setFilter3(val)
global f3
f3 = val;

function r = getFilter3
global f3
r = f3;

% --- track min max
function setTrackingMinMax(val)
global TrackingMinMax
TrackingMinMax = val;

function r = getTrackingMinMax
global TrackingMinMax
r = TrackingMinMax;

% --- min max
function r = getMinMax
global MinMax
r = MinMax;

function setMinMax(val)
global MinMax
MinMax = val;

% val should be [min,max]
function addMinMaxValue(val)
global MinMax
MinMax = [MinMax; val];

function removeMinMaxValue
global MinMax
%to be defined

% --- track point
function setTrackingPoint(val)
global TrackingPoint
TrackingPoint = val;

function r = getTrackingPoint
global TrackingPoint
r = TrackingPoint;

% -- points
function setPoint(val)
global Marker
Marker = val;

function r=getPoint
global Marker
r=Marker;

function setPointTemp(val)
global MarkerTemp
MarkerTemp = val;

function addPointTemp(val)
global MarkerTemp
MarkerTemp = [MarkerTemp, val];

function r = getPointTemp
global MarkerTemp
r=MarkerTemp;

%added for HProp
function setIsRecIS2Seq(val)
global RecIS2Seq
RecIS2Seq = val;

function r = getIsRecIS2Seq
global RecIS2Seq
r=RecIS2Seq;

function setMSPerIs2(val)
global MSPerIs2
MSPerIs2 = val;

function r = getMSPerIs2
global MSPerIs2
r=MSPerIs2;

function setLastTimeStamp(val)
global lastTS
lastTS = val;

function r = getLastTimeStamp
global lastTS
r=lastTS;

function setSeqPath(val)
global seqPath
seqPath = val;

function r = getSeqPath
global seqPath
r=seqPath;

% --- Executes on mouse press over axes background.
function IMG_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to IMG (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function MSPerIS2_Callback(hObject, eventdata, handles)
% hObject    handle to MSPerIS2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of MSPerIS2 as text
%        str2double(get(hObject,'String')) returns contents of MSPerIS2 as a double


% --- Executes during object creation, after setting all properties.
function MSPerIS2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to MSPerIS2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in SetMSPerIS2.
function SetMSPerIS2_Callback(hObject, eventdata, handles)
% hObject    handle to SetMSPerIS2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%grab the text from the text box
text = get(handles.MSPerIS2,'String');
%convert to num
numMS = str2num(text);
%set global
setMSPerIs2(numMS);

% --- Executes on button press in DisableFineOffset.
function DisableFineOffset_Callback(hObject, eventdata, handles)
% hObject    handle to DisableFineOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
camip= char(Fluke.Thermography.IRAccess.Streaming.StreamingCameraEngine.Instance.ConnectedDevice().Device.DiscoveryInfo.DeviceIp);
url = strcat('http://', camip, '/engine/:SET%20AUTOFINE%200');
data = webread(url);
%response = webwrite(url,data);

% --- Executes on button press in EnableFineOffset.
function EnableFineOffset_Callback(hObject, eventdata, handles)
% hObject    handle to EnableFineOffset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
camip= char(Fluke.Thermography.IRAccess.Streaming.StreamingCameraEngine.Instance.ConnectedDevice().Device.DiscoveryInfo.DeviceIp);
url = strcat('http://', camip, '/engine/:SET%20AUTOFINE%201');
data = webread(url);
%response = webwrite(url,data);


% --- Executes on button press in RecordIS2Sequence.
function RecordIS2Sequence_Callback(hObject, eventdata, handles)
% hObject    handle to RecordIS2Sequence (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.RecordIS2Sequence,  'Enable', 'off');
global gImgSrcMgr;
%default path is current folder
%path = pwd;

%check the field to change path
% userPath = get(handles.SaveFileLocation, 'string');
% if exist(userPath)==7
%     path=userPath;
% else
%     path = uigetdir;
% end
% %one last check to make sure the path exists
% if exist(path)~=7
%     path = pwd;
% end

%update the location so the user will know where that file just went
%set(handles.SaveFileLocation, 'string', path);

userPath = get(handles.SaveFileLocation, 'string');
setSeqPath(userPath);
%set the global variable
setLastTimeStamp(clock);
setIsRecIS2Seq(true);


%enable stop now
set(handles.StopIS2Seq,  'Enable', 'on');


% --- Executes on button press in StopIS2Seq.
function StopIS2Seq_Callback(hObject, eventdata, handles)
% hObject    handle to StopIS2Seq (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%only want to perform action once
set(handles.StopIS2Seq,  'Enable', 'off');
%set the prop to stop the sequencing
setIsRecIS2Seq(false);
%allow user to start new sequence again
set(handles.RecordIS2Sequence,  'Enable', 'on');


% --- Executes on button press in FireNUC.
function FireNUC_Callback(hObject, eventdata, handles)
% hObject    handle to FireNUC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%find cam ip
camip= char(Fluke.Thermography.IRAccess.Streaming.StreamingCameraEngine.Instance.ConnectedDevice().Device.DiscoveryInfo.DeviceIp);

%fire  set shutter
url = strcat('http://', camip, '/engine/:SHUTTER%20MOVE%201%201');
data = webread(url);

%wait a bit
pause(0.1);

%remove shutter
url = strcat('http://', camip, '/engine/:SHUTTER%20MOVE%201%202');
data = webread(url);
